package org.processmining.dataawarereplayer.precision.state;

import org.processmining.plugins.balancedconformance.dataflow.datastate.DataState;

public final class DPNStateImpl implements DPNState {

	private final DataState dataState;
	private final byte[] marking;

	public DPNStateImpl(byte[] marking, DataState dataState) {
		super();
		this.marking = marking;
		this.dataState = dataState;
	}

	public byte[] getMarking() {
		return marking;
	}

	public DataState getDataState() {
		return dataState;
	}

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((dataState == null) ? 0 : dataState.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		DPNStateImpl other = (DPNStateImpl) obj;
		if (dataState == null) {
			if (other.dataState != null)
				return false;
		} else if (!dataState.equals(other.dataState))
			return false;
		return true;
	}

	public String toString() {
		return String.format("%s", dataState);
	}

}