package org.processmining.dataawarereplayer.precision.visualizer;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.dataawarereplayer.precision.PrecisionResult;
import org.processmining.datapetrinets.DataPetriNet;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "0 Project Precision Measurement on Net", returnLabels = { "Multi-perspective Precision Measurement" }, //
		returnTypes = { JComponent.class }, level = PluginLevel.PeerReviewed, userAccessible = true, parameterLabels = { "Matching Instances" })
@Visualizer
public class PrecisionResultVisualizerPlugin {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualise(PluginContext context, PrecisionResult result) {
		return visualise(context, (DataPetriNet) result.getModel(), result);
	}

	public static JComponent visualise(PluginContext context, DataPetriNet net, PrecisionResult precisionResult) {
		return new PrecisionResultVisualizerPanel(context, net, precisionResult);
	}

}
