package org.processmining.models.DCNet.visualization;

import java.util.Set;

import org.processmining.models.DCNet.DCNet;
import org.processmining.models.DCNet.DCNetBinding;
import org.processmining.models.DCNet.DCNetNode;
import org.processmining.models.cnet.CNet;
import org.processmining.models.cnet.CNetBinding;
import org.processmining.models.cnet.CNetNode;
import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.directed.AbstractDirectedGraph;
import org.processmining.models.visualcnet.CNetVEdge;
import org.processmining.models.visualcnet.CNetVNode;
import org.processmining.plugins.DataConformance.Utility;

public class DCNetVNode extends CNetVNode 
{

	private DCNet dnet;

	public DCNetVNode(DCNetV graph, CNetVNode origNode) 
	{
		super(graph, origNode);
	}

	public DCNetVNode(AbstractDirectedGraph<CNetVNode, CNetVEdge> graph, CNetNode node, CNet net) {
		super(graph, node, net);
		dnet=(DCNet)net;
		String guard=((DCNetNode)node).getGuard().trim();
		tooltip = "<html><table>";
		
		if (guard.equals("1"))
			guard="";
		String label="<html><table><tr><td><center><p style='font-size: 90%'>[" + 
			Utility.encodeTextAsHTML(guard) + "]</p></center></td></tr><tr><td><center><b>" +
			node.getLabel()+"</b></center></td></tr></table></html>";
		getAttributeMap().put(AttributeMap.LABEL, label);
		tooltip+="<tr><td colspan=\"2\"><center><strong>" + node.getLabel() + "</strong></center></td></tr>" + 
		"<tr><td VALIGN=\"top\"><strong>In:</strong></td><td>" + getInNodesLabel(node) + "</td></tr>" +
		"<tr><td VALIGN=\"top\"><strong>Out:</strong></td><td>" + getOutNodesLabel(node) + "</td></tr>"+
		"<tr><td></td><td></td></tr>";
		tooltip+="</table></html>";	
		getAttributeMap().put(AttributeMap.TOOLTIP, getToolTipText());
	}
	
	private String getNodesLabel(Set<CNetBinding> nodes) {
		int counter = 0;
		int size = 0;

		StringBuffer strBuf = new StringBuffer();
		for (CNetBinding c : nodes) {
			DCNetBinding node = (DCNetBinding) c;
			counter = 0;
			size = node.getBoundNodes().size();
			strBuf.append("(");
			strBuf.append("{");
			for (CNetNode out : node.getBoundNodes()) {
				counter++;
				strBuf.append(out.getLabel());
				if (counter < size) {
					strBuf.append(",");
				}
			}
			strBuf.append("},[");
			strBuf.append(Utility.encodeTextAsHTML(node.getDataExpression()));
			strBuf.append("]");
			strBuf.append(")<br>");
		}
		return strBuf.toString();
	}

	private String getOutNodesLabel(CNetNode node) 
	{
		String text=getNodesLabel(dnet.getOutputBindings(node));
		return text;
	}
	
	private String getInNodesLabel(CNetNode node) 
	{
		String text=getNodesLabel(dnet.getInputBindings(node));
		return text;
	}	

}
