package org.processmining.models.DCNet.visualization;

import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import org.processmining.framework.util.ui.scalableview.ScalableComponent;
import org.processmining.framework.util.ui.scalableview.ScalableViewPanel;
import org.processmining.framework.util.ui.scalableview.interaction.ViewInteractionPanel;
import org.processmining.framework.util.ui.widgets.ProMTable;
import org.processmining.models.DCNet.DCNet;

public class VariablePnl extends ProMTable implements ViewInteractionPanel 
{
	private DCNet cnet;
	private JTable tab;
	
	public VariablePnl(DCNet cnet)
	{
		super(new DefaultTableModel(getTableValue(cnet), new Object[]{"Variable Name","Values"}));

	}
	
	@SuppressWarnings("unchecked")
	private static Object[][] getTableValue(DCNet cnet)
	{
		Object[][] tableValue=new Object[cnet.getVariables().size()][2];
		int row=0;
		for(String variable : cnet.getVariables())
		{
			tableValue[row][0]=variable;
			StringBuffer buffer=new StringBuffer();
			LinkedList<Comparable> mySet=new LinkedList<Comparable>(cnet.getSetValues(cnet.getSetForVariable(variable)));
			Collections.sort(mySet);
			Iterator<Comparable> iter=mySet.iterator();
			if (iter.hasNext())
				buffer.append(" "+iter.next());
			while(iter.hasNext())
				buffer.append(", "+iter.next());
			tableValue[row++][1]=buffer;
		}
		return tableValue;
	}
	
	public JComponent getComponent() 
	{
		return this;
	}

	public synchronized double getHeightInView() 
	{
		return 0.4;
	}

	public String getPanelName() 
	{
		return "Variable";
	}

	public synchronized double getWidthInView() 
	{
		return 0.5;
	}

	public void setParent(ScalableViewPanel viewPanel) 
	{
		// TODO Auto-generated method stub

	}

	public void setScalableComponent(ScalableComponent scalable) {
		// TODO Auto-generated method stub

	}

	public void willChangeVisibility(boolean to) {
		// TODO Auto-generated method stub

	}

	public void updated() {
		// TODO Auto-generated method stub

	}

}
