package org.processmining.plugins.DataConformance.DataAlignment;

import java.util.Map;
import java.util.Set;

import org.processmining.models.guards.Expression;


public interface IControlFlowAlignmentStep<P, L> {
	
	public final static int MOVE_IN_LOG=0;
	public final static int MOVE_IN_MODEL_VISIBLE=1;
	public final static int MOVE_IN_MODEL_INVISIBLE=2;
	public final static int MOVE_IN_BOTH=3;

	String getActivityName();
	int getMoveType();
	
	P getProcessObject();
	
	/**
	 * Please use {@link #getProcessObject()} and look for the guard there instead!
	 */
	@Deprecated
	Expression getGuardExpression();
	
	Set<String> getVariableToWrite();
	
	L getLogObject();
	Map<String, Object> getVariableAssignments();	

}
