package org.processmining.plugins.DataConformance.GUI;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.plugins.DataConformance.framework.ActivityMatchCost;
import org.processmining.plugins.DataConformance.framework.ReplayableActivity;

public class ActivityMatchingTableModel extends AbstractTableModel
{
	private static final long serialVersionUID = 1L;
	private Vector<ActivityMatchCost> values=new Vector<ActivityMatchCost>();
	
	public ActivityMatchingTableModel()
	{
		ActivityMatchCost amc1=new ActivityMatchCost();
		amc1.setAllProcessActivities(true);
		amc1.setCost(10);
		ActivityMatchCost amc2=new ActivityMatchCost();
		amc2.setAllEvents(true);
		amc2.setCost(10);
		values.add(amc1);
		values.add(amc2);
	}
	
	public int getColumnCount() {
		return 3;
	}

	public int getRowCount() {
		return values.size();
	}
	
	public boolean isCellEditable(int rowIndex, int columnIndex)
	{
		if (rowIndex>=values.size()-2 && columnIndex<2)
			return false;
		else
			return true;
	}
	
	public String getColumnName(int column)
	{
		switch(column)
		{
			case 0:
				return "Log Event Class";
			case 1:
				return "Process Activity";
			case 2:
				return "Cost";
			default:
				return "";
		}
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		ActivityMatchCost value=values.get(rowIndex);
		switch(columnIndex)
		{
			case 0: 
				if (value.isAllEvents())
					return "*";
				else if (value.getEventClass()==null)
					return "";
				else
					return value.getEventClass();
			case 1:
				if (value.isAllProcessActivities())
					return  "*";
				else if (value.getProcessActivity()==null)
					return "";
				else
					return value.getProcessActivity();
			case 2:	
				return value.getCost();
		}
		return "";
	}
	
	public void addRow(int index)
	{
		if (index>values.size()-2)
			index=values.size()-2;
		values.add(index, new ActivityMatchCost());
	}
	
	public void setValueAt(Object aValue, int rowIndex, int columnIndex)
	{
		ActivityMatchCost value=values.get(rowIndex);
		switch(columnIndex)
		{
			case 0:
				if (aValue.equals(""))
					value.setEventClass(null);
				else
				{
					value.setEventClass((XEventClass) aValue);
				}
				break;
			case 1:
				if (aValue.equals(""))
					value.setProcessActivity(null);
				else
				{
					value.setProcessActivity((ReplayableActivity) aValue);
				}				
				break;
			case 2:
				value.setCost(Float.parseFloat((String)aValue));
		}		
	}

	public List<ActivityMatchCost> getValues() 
	{
		return Collections.unmodifiableList(values);
	}

	public void removeRow(int[] indexes) 
	{
		Arrays.sort(indexes);
		for(int i=indexes.length-1;i>=0;i--)
			if (indexes[i]>=0 && indexes[i]<values.size()-2) values.remove(indexes[i]);
	}
}
