package org.processmining.plugins.DataConformance.framework;

import java.util.Collections;
import java.util.List;

public class ReplayState implements Comparable<ReplayState>
{
	protected ExecutionTrace processTracePrefix;
	protected ExecutionTrace logTracePrefix;
	protected float f_cost=0;
	protected float h_cost=0;
	public int visitedNodes;
	public long treeSize;
	
	public int compareTo(ReplayState o) 
	{
		int compareF=0;
		if (Math.abs(f_cost-o.f_cost)>0.05)
			compareF=Float.compare(f_cost, o.f_cost);
		if (compareF!=0)
			return compareF;
		else 
		{
			int val=logTracePrefix.lengthExecutionTraceWithoutBottomSteps();
			val+=processTracePrefix.lengthExecutionTraceWithoutBottomSteps();
			int val2=o.logTracePrefix.lengthExecutionTraceWithoutBottomSteps();
			val2+=o.processTracePrefix.lengthExecutionTraceWithoutBottomSteps();
			return Float.compare(val2, val);
		}
	}
	
	public String toString()
	{
		StringBuffer buffer=new StringBuffer("[P: ");
		buffer.append(processTracePrefix).append(", L:").append(logTracePrefix).append(']');
		buffer.append("f: ").append(f_cost);
		buffer.append(" g: ").append((f_cost-h_cost)).append(" h:").append(h_cost);
		return buffer.toString();
	}

	public List<ExecutionStep> getProcessTracePrefix() {
		return Collections.unmodifiableList(processTracePrefix);
	}

	public List<ExecutionStep> getLogTracePrefix() {
		return Collections.unmodifiableList(logTracePrefix);
	}

	public String getTraceName() {
		return logTracePrefix.getTraceName();
	}

	public float getCost() {
		return f_cost;
	}



}