/*
 * Copyright (c) 2013 F. Mannhardt (f.mannhardt@tue.nl)
 */
package org.processmining.plugins.balancedconformance.controlflow;

/**
 * Thrown when the control flow alignment fails for whatever reason. In case the
 * control flow alignment was stopped by a limit before computing the optimal
 * solution, the subclass {@link UnreliableControlFlowAlignmentException} is
 * thrown.
 * 
 * @author F. Mannhardt
 */
public class ControlFlowAlignmentException extends Exception {

	private static final long serialVersionUID = 8071829964207698025L;

	public ControlFlowAlignmentException() {
		super();
	}

	public ControlFlowAlignmentException(String message, Throwable cause) {
		super(message, cause);
	}

	public ControlFlowAlignmentException(String message) {
		super(message);
	}

	public ControlFlowAlignmentException(Throwable cause) {
		super(cause);
	}

}
