package org.processmining.plugins.balancedconformance.dataflow.exception;

import org.deckfour.xes.model.XTrace;
import org.processmining.plugins.balancedconformance.controlflow.UnreliableControlFlowAlignmentException;

public class UnreliableDataAlignmentException extends DataAlignmentException {
	
	public enum UnreliableReason {
		CANCELLED, MAXCOST, IMPOSSIBLE
	}

	private static final long serialVersionUID = -7397522773230266222L;
	
	private final UnreliableReason reason;
	private final XTrace trace;
	
	public UnreliableDataAlignmentException(UnreliableControlFlowAlignmentException e, UnreliableReason reason, XTrace trace) {
		super(e);
		this.reason = reason;
		this.trace = trace;
	}
	
	public UnreliableDataAlignmentException(String message, UnreliableControlFlowAlignmentException e, UnreliableReason reason, XTrace trace) {
		super(message, e);
		this.reason = reason;
		this.trace = trace;
	}

	public UnreliableReason getReason() {
		return reason;
	}

	public XTrace getTrace() {
		return trace;
	}

}
