/*
 * Copyright (c) 2013 F. Mannhardt (f.mannhardt@tue.nl)
 */
package org.processmining.plugins.balancedconformance.observer;

import java.util.Collection;
import java.util.logging.Level;

import org.deckfour.xes.model.XTrace;
import org.processmining.plugins.balancedconformance.result.BalancedDataAlignmentState;
import org.processmining.plugins.balancedconformance.result.DataAlignedTrace;

import com.google.common.base.Throwables;

public class DataConformancePlusObserverNoOpImpl implements DataConformancePlusObserver {

	public void processingNewTrace(int traceIndex, XTrace trace) {
	}

	public void foundOptimalAlignment(int traceIndex, XTrace trace, DataAlignedTrace dataAlignment,
			int partialDataAlignmentsNeeded, int cacheHit, int cacheSize, long queuedStates, long dataStateCount,
			long usedTime) {
	}
	
	public void foundImpossibleAlignments(Collection<ImpossibleTrace> impossibleTraces) {
	}

	public void slowDataAlignmentDetected(int traceIndex, XTrace trace, DataAlignedTrace dataAlignment, long usedTime) {
	}

	public void unreliableAlignmentDetected(int traceIndex, XTrace currentTrace) {
	}

	public void log(String message) {
		log(Level.INFO, message);
	}

	public void log(String message, Throwable e) {
		log(Level.SEVERE, message + "\n" + Throwables.getStackTraceAsString(e));
	}

	public void log(Level level, String message) {
	}

	public void finishedAlignment() {
	}

	public void startAlignment(int numExpectedResults) {
	}

	public void calculatedFitness(int traceIndex, XTrace trace, BalancedDataAlignmentState resultState) {
	}

}