/*
 * Copyright (c) 2013 F. Mannhardt (f.mannhardt@tue.nl)
 */
package org.processmining.plugins.balancedconformance.result;

import java.io.Serializable;

/**
 * @author F. Mannhardt
 *
 */
public class StatisticResult implements Serializable {
	
	public static final String TIME_PER_TRACE = "timePerTrace";
	public static final String CACHE_SIZE = "cacheSize";
	public static final String CACHE_HITS = "cacheHits";
	public static final String UNRELIABLE_ALIGNMENTS = "unreliable";
	public static final String IGNORED_LOOPS = "ignoredLoops";
	public static final String QUEUED_STATES = "queuedRecords";
	public static final String MILP_PROBLEMS_SOLVED = "dfAlignments";
	public static final String FITNESS = "fitness";
	public static final String TRACE_LENGTH = "traceLength";
	
	private static final long serialVersionUID = 4543276028186904481L;
	
	private double[] data;
	private boolean[] dataBool;
	final private String name;
	final private String xAxis;
	final private String yAxis;

	public StatisticResult(String name, double[] data, String xAxis, String yAxis) {
		this.name = name;
		this.data = data;
		this.xAxis = xAxis;
		this.yAxis = yAxis;
	}

	public StatisticResult(String name, boolean[] data, String xAxis, String yAxis) {
		this.name = name;
		this.dataBool = data;
		this.xAxis = xAxis;
		this.yAxis = yAxis;
	}

	public boolean isBoolean() {
		return dataBool != null;
	}

	public double[] getData() {
		return data;
	}

	public boolean[] getDataBool() {
		return dataBool;
	}

	public String getName() {
		return name;
	}

	public String getxAxis() {
		return xAxis;
	}

	public String getyAxis() {
		return yAxis;
	}
}